package com.company.testsuggfield.web.order;

import com.company.testsuggfield.entity.Customer;
import com.google.common.collect.ImmutableMap;
import com.haulmont.chile.core.model.MetaClass;
import com.haulmont.cuba.core.global.DataManager;
import com.haulmont.cuba.core.global.Metadata;
import com.haulmont.cuba.gui.components.SuggestionPickerField;
import com.haulmont.cuba.gui.screen.*;
import com.company.testsuggfield.entity.Order;

import javax.inject.Inject;
import java.util.List;
import java.util.Map;

@UiController("testsuggfield_Order.edit")
@UiDescriptor("order-edit.xml")
@EditedEntityContainer("orderDc")
@LoadDataBeforeShow
public class OrderEdit extends StandardEditor<Order> {

    @Inject
    private SuggestionPickerField<Customer> customer1Field;

    @Inject
    private DataManager dataManager;

    @Subscribe
    private void onAfterInit(AfterShowEvent event) {
        customer1Field.setSearchExecutor((searchString, searchParams) ->
                dataManager.load(Customer.class)
                        .query("select e from testsuggfield_Customer e where e.name like :searchString")
                        .setParameters(ImmutableMap.of("searchString", "%" + searchString + "%"))
                        .list());
    }

    @Install(to = "customer2Field", subject = "searchExecutor")
    private List customer2FieldSearchExecutor(String searchString, Map<String, Object> searchParams) {
        return dataManager.load(Customer.class)
                .query("select e from testsuggfield_Customer e where e.name like :searchString")
                .setParameters(ImmutableMap.of("searchString", "%" + searchString + "%"))
                .list();
    }
}